#!/usr/bin/env python3
# -*- coding: utf-8 -*-
#from frangiPANe.global_variables import *
from frangiPANe import generate_stats as gs
from .module import FrangiPANe
from pathlib import Path
from .global_variables import GIT_URL, DOCS, DATATEST_URL_FILES, SINGULARITY_URL_FILES

#TODO SEB : LOGO https://forge.ird.fr/diade/frangipane/-/blob/main/docs/source/_images/frangiPANe.png?ref_type=heads
logo = Path(__file__).parent.resolve().joinpath('frangiPANe.png').as_posix()

__version__ = Path(__file__).parent.resolve().joinpath("VERSION").open("r").readline().strip()

__doc__ = """frangiPANe was developed as a modular and interactive application to simplify the construction of a panreference 
using the map-then-assembly approach. It consists in a Jupyter Notebook application that centralizes code,documentation and interactive visualizations together"""

description_tools = f"""
                                    
                                    
                                                                                                                        
   ad88                                                    88  88888888ba      db         888b      88              
  d8'                                                      ''  88      "8b    d88b        8888b     88              
  88                                                           88      ,8P   d8'`8b       88 `8b    88              
MM88MMM  8b,dPPYba,  ,adPPYYba,  8b,dPPYba,    ,adPPYb,d8  88  88aaaaaa8P'  d8'  `8b      88  `8b   88   ,adPPYba,  
  88     88P'   "Y8  ''     `Y8  88P'   `"8a  a8"    `Y88  88  88'''''''   d8YaaaaY8b     88   `8b  88  a8P_____88  
  88     88          ,adPPPPP88  88       88  8b       88  88  88         d8''''''''8b    88    `8b 88  8PP''''''  
  88     88          88,    ,88  88       88  "8a,   ,d88  88  88        d8'        `8b   88     `8888  '8b,   ,aa  
  88     88          `'8bbdP'Y8  88       88   `'YbbdP'Y8  88  88       d8'          `8b  88      `888   `'Ybbd8''  
                                               aa,    ,88                                                           
                                                'Y8bbdP'                                                            
 
A modular and interactive application to simplify  the construction of a panreference  using the map-then-assembly approach."

    Version {__version__}
    
    @author: Sebastien Ravel and Christine Tranchant
    @email: christine.tranchant@ird.fr

    Please cite our github: GIT_URL
    
    Licencied under CeCill-C (http://www.cecill.info/licences/Licence_CeCILL-C_V1-en.html)
    and GPLv3 Intellectual property belongs to IRD, CIRAD and authors.
    
    Documentation avail at: DOCS

"""

dico_tool = {
    "soft_path": Path(__file__).resolve().parent.as_posix(),
    "url": GIT_URL,
    "docs": DOCS,
    "description_tool": description_tools,
    "singularity_url_files": SINGULARITY_URL_FILES,
    "datatest_url_files": DATATEST_URL_FILES,
    "snakefile": Path(__file__).resolve().parent.joinpath("snakefiles", "Snakefile"),
    "snakemake_scripts": Path(__file__).resolve().parent.joinpath("snakemake_scripts")
}
