rule bwa_index:
    input:
        ref=f"{frangipane_obj.path_reference_dir}/{{ref_name}}.fasta"
    output:
        list_index = expand(f"{frangipane_obj.path_reference_dir}/{{{{ref_name}}}}.fasta.{{ref_index}}", ref_index=ref_index)
    log:
         error =  f"{frangipane_obj.path_logs}/bwa_index/{{ref_name}}.e",
         output = f"{frangipane_obj.path_logs}/bwa_index/{{ref_name}}.o"
    params:
        other_options = " "
    message:
         f"""--------------------
-Running {{rule}}
|-- Input:
|   - Fasta : {{input.ref}}
|-- Output:
|   - index_file: {{output}} 
|-- Others infos :
|   -LOG output: {{log.output}}
|   -Other options: {{params.other_options}}
--------------------
"""
    singularity:
        tools_config['SINGULARITY']['TOOLS']
    envmodules:
        tools_config["ENVMODULE"]["BWA"]
    shell:
        """
        cmd='bwa index {params.other_options} {input.ref}' ; 
        echo $cmd > {log.output};
        ($cmd) 1>> {log.output} 2> {log.error};"""
        