from snakemake.utils import validate

from pprint import pp
from pathlib import Path,PurePosixPath

#TODO 29/11 : gestion fastq pairé
FASTQ, = glob_wildcards(f"{frangipane_obj.path_fastq}/{{fastq_file}}.fastq.gz")
REF, = glob_wildcards(f"{frangipane_obj.path_reference_dir}/{{ref_name}}.fasta")
SAMPLES, = glob_wildcards(f"{frangipane_obj.path_fastq}/{{sample_name}}_1.fastq.gz")

bam_index = ['bam','bam.bai']
ref_index = ["amb", "ann", "bwt", "pac", "sa"]

#print(SAMPLES)
#print(REF)

def get_output_final(wildcards):
    
    dico_output = {}

    if frangipane_obj.activated_MAPPING_REF:

        #TODO 29/11: to update
        if "panref" in REF:
            raise ValueError(f"####### ERROR : you already have a panref file in your reference directory {frangipane_obj.path_reference_dir}")

        dico_output.update({
                "bwa_index" : expand(rules.bwa_index.output.list_index, ref_name=[frangipane_obj.reference_basename], ref_index=[ref_index])})

        dico_output.update({
                "bwa_mem" : expand(rules.bwa_mem.output.bam_file, sample_name=SAMPLES, ref_name=[frangipane_obj.reference_basename])}),

        dico_output.update({
                "samtools_flagstat": expand(rules.samtools_flagstat.output.stat_file,sample_name=SAMPLES,ref_name=REF)})

        dico_output.update({
                "samtools_view" : expand(rules.samtools_view.output.bam_file, sample_name=SAMPLES, ref_name=REF)}),

    if frangipane_obj.activated_ASSEMBLY:

        dico_output.update({
            "abyss" : expand(rules.abyss.output.abyss_file, sample_name=SAMPLES, ref_name=REF)}),

        dico_output.update({
                 "abyss_merge" : rules.abyss_merge.output.merged_fasta}),

        dico_output.update({
                "cdhit" : rules.cdhit.output }),

        dico_output.update({
            "filter_length": expand(rules.filter_length.output.fasta_file,sample_name=SAMPLES,ref_name=REF)}),

        dico_output.update({
                    "vecscreen": expand(rules.vecscreen.output.fasta_file,sample_name=SAMPLES,ref_name=REF)}),

    if frangipane_obj.activated_REPORT:

                # STAT FASTQ
        dico_output.update({
                "fastq_stats" : expand(rules.fastq_stats.output.stat_file, fastq_file=FASTQ) })

        dico_output.update({
                "merge_fastq_stats" : rules.merge_fastq_stats.output })

        dico_output.update({
                "plot_fastq" : rules.plot_fastq.output})

            # STAT ASSEMBLY
        dico_output.update({
                "fasta_stats2" : rules.fasta_stats2.output}),

        if not "panref" in REF:
            dico_output.update({
                "fasta_stats" : rules.fasta_stats.output}),

            # STAT MAPPING
        dico_output.update({
                "merge_flagstat" : rules.merge_flagstat.output.stat_file })


        dico_output.update({
                "plot_mapping" :rules.plot_mapping.output.png_mapping})

        dico_output.update({
                   "report": rules.generate_jupyter_book.output.jb_file})


    if frangipane_obj.activated_BUILD_PANREF and not 'panref' in REF:

        dico_output.update({
                #"create_panref" : rules.create_panref.output.fasta_file_ln,
                #"bwa_index2" : expand(rules.bwa_index.output.list_index, ref_name=['panref'], ref_index=[ref_index]),
                "bwa_mem2" : expand(rules.bwa_mem.output.bam_file, sample_name=SAMPLES, ref_name=['panref'])
                })
   
    return dico_output

