rule create_panref:
    input:
        cluster_file = rules.cdhit.output.fasta_file,
        ref_file = frangipane_obj.path_reference_file
    output:
        fasta_file = f"{frangipane_obj.path_panreference}/panref.fasta",
        fasta_file_ln = f"{frangipane_obj.path_reference_dir}/panref.fasta"
    log:
        error =  f"{frangipane_obj.path_logs}/clustering/create_panref.e",
        output = f"{frangipane_obj.path_logs}/clustering/create_panref.o"
    message:
        f"""--------------------
-Running {{rule}}
|-- Input:
|   - Fasta : {{input.cluster_file}}, {{input.ref_file}}
|-- Output:
|   - Fasta file: {{output.fasta_file}} 
|-- Others infos :
|   -LOG output: {{log.output}}
--------------------
"""
    run:
        cmd=f"cat {input.ref_file} {input.cluster_file} >> {output.fasta_file}"
        print(cmd)

        process = subprocess.run(cmd, shell=True, capture_output=True, text=True)
        if process.returncode != 0:
            raise ValueError(f"Error executing command: {process.stderr}")

        cmd2=f"ln -fs {output.fasta_file} {frangipane_obj.path_reference_dir}"
        print(cmd2)

        try:
            process2 = subprocess.run(cmd2, shell=True, text=True)
        except Exception as e:
            #if process2.returncode != 0:
            raise ValueError(f"Error executing command: {process2.stderr}")

        frangipane_obj.path_bam = {frangipane_obj.path_bam_panref}


