#!/usr/bin/env python3

# License GNU/GPL
# Intellectual property belongs to IRD
# written by Christine Tranchant-Dubreuil (UMR DIADE/itrop platform - IRD)

"""

    Script to generate a plot of the size in pb for each chromosome
    :Example:
    >>> python %(prog)s -r reference -o output_directory

"""

import argparse
import generate_stats as gs

def main():

    #get arguments
    parser = argparse.ArgumentParser(usage='%(prog)s [options]',
                                     description='Python script to parse bam file ',
                                     epilog="""Author : C. Tranchant-Dubreuil (UMR DIADE / Rice Team - IRD) \n
                                              ,--------------------""")

    parser.add_argument('-r','--ref', help='reference (fasta format)', required=True)
    parser.add_argument('-o','--out', help='directory to save plot and csv created', required=True)
    args = parser.parse_args()

    # get parameters
    output_dir = args.out
    ref_file = args.ref

    total_genome_size=gs.dashboard_genome(ref_file, output_dir)
    print(total_genome_size)


if __name__ == "__main__":
    main()
